/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 30                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm demonstriert fuer Pointer die Anwendung der    */
/* Referezierungs- und Dereferenzierungs-Operatoren & und *.   */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

main() {

 int *pt1, *pt2;
 int var1 = 100, var2 = 200;

 pt1  = &var1;       /* pt1 zeigt nun auf var1 */
 pt2  = pt1;         /* pt2 zeigt nun auch auf var1 */

 *pt1 = *pt1 + 1;    /* entspricht var1 = var1 + 1; */

 pt1  = &var2;       /* pt1 zeigt nun auf var2 */
 (*pt1)++;           /* entspricht var2 = var2 + 1; */
 *pt2 = 150;         /* entspricht var1 = 150; */

 pt1  = &var1;
 pt2  = &var2;
 *pt2 = *pt1;        /* entspricht var2 = var1; */
 *pt2 = 300;         /* entspricht var2 = 300; */

 pt2  = pt1;         /* pt2 und pt1 zeigen nun auf var1 */
 *pt2 = 300;         /* entspricht var1 = 300; */

 getch();

}
