/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 41                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm ist ein erstes Beispiel zur Benutzung von      */
/* Funktionen.                                                 */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

/*** Funktion max() zur Ermittlung des Maximums dreier int-Zahlen,
     die ueber die Parameter wert_1 - 3 uebergeben werden ***/
     
int max(int wert_1,int wert_2,int wert_3) {

 int wert_max; /* Hilfsvariable zur schrittweisen Ermittlung des Maximums */

 wert_max = wert_1;
 if (wert_2>wert_max)
             wert_max = wert_2;
 if (wert_3>wert_max)
             wert_max = wert_3;
 return wert_max; /* Rueckgabe des ermittelten Werts */

} /* Ende der Funktionsdeklaration */

/*** Hauptprogramm ***/

main() {

 /* Deklaration von neun Variablen. Sie geben fuer drei Studenten
    (numeriert von 1 bis 3) ihre Punktzahlen in der DV-, Mathe-
    und Physikklausur an. */

 int punkte_dv_1, punkte_dv_2, punkte_dv_3;
 int punkte_ma_1, punkte_ma_2, punkte_ma_3;
 int punkte_ph_1, punkte_ph_2, punkte_ph_3;

 /* Die naechsten drei Variablen sollen die maximal erreichten
    Punktzahlen in der DV-, der Mathe- und der Physikklausur
    enthalten. Ihre Werte werden durch das Programm aus den oben
    angegebenen neun Werten berechnet. */

 int punkte_dv_max, punkte_ma_max, punkte_ph_max;

 /* Eingabe der Einzelergebnisse */

 printf("Stud. 1: DV, MA, PH ");
 scanf("%d %d %d",&punkte_dv_1,&punkte_ma_1,&punkte_ph_1);
 printf("\n");
 printf("Stud. 2: DV, MA, PH ");
 scanf("%d %d %d",&punkte_dv_2,&punkte_ma_2,&punkte_ph_2);
 printf("\n");
 printf("Stud. 3: DV, MA, PH ");
 scanf("%d %d %d",&punkte_dv_3,&punkte_ma_3,&punkte_ph_3);
 printf("\n");

 /* Aufruf von max(): Berechnung der maximalen Punktzahl der DV-Klausur */

 punkte_dv_max = max(punkte_dv_1,punkte_dv_2,punkte_dv_3);

 /* Aufruf von max(): Berechnung der maximalen Punktzahl der DV-Klausur */

 punkte_ma_max = max(punkte_ma_1,punkte_ma_2,punkte_ma_3);

 /* Aufruf von max(): Berechnung der maximalen Punktzahl der DV-Klausur */

 punkte_ph_max = max(punkte_ph_1,punkte_ph_2,punkte_ph_3);

 /* Ausgabe des Ergebnisses */

 printf("In DV maximal: %3d\n",punkte_dv_max);
 printf("In MA maximal: %3d\n",punkte_ma_max);
 printf("In PH maximal: %3d\n",punkte_ph_max);

 getch();

}
