/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 55                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm demonstriert die Vorgehensweise                */
/* bei bedingter Compilierung.                                 */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

#define TESTVERSION

/* Nach #define TESTVERSION werden alle Programmteile, die
   durch #ifdef TESTVERSION ... #endif geklammert sind, mit
   uebersetzt,
   nach #undef TESTVERSION (oder einfach Weglassen der
   #define-Zeile) werden sie ignoriert.
   Hierdurch kann man z.B. (wie hier) bestimmte printf()-
   Ausgaben zunaechst mituebersetzen, um sich aus Testzwecken
   bestimmte Variablenwerte ausgeben zu lassen. In die end-
   gueltige Programmversion werden diese aber nicht aufgenommen.
   Statt TESTVERSION kann hier natuerlich jeder beliebige
   andere Name verwendet werden. */

main() {

 /* Deklaration und Initialisierung von Beispielvariablen */

 int vektor[5] = { 2, 5, 11, 3, 0 },
     i = 3,
     j = 4711;

 printf("Erster Programmteil\n\n");

 /* Zuweisung, deren beteiligte Werte in der Testversion
    ausgegeben werden sollen */

 vektor[i] = j;

 /* Ausgabe der Werte (nur in der Testversion) */

 #ifdef TESTVERSION
 printf("i = %d, vektor[i] = %d",i,vektor[i]);
 #endif

 printf("\n\nZweiter Programmteil\n\n");

 getch();

}
