/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Beispielprogramm Nr. 65                                     */
/* der frueheren Vorlesung Datenverarbeitung                   */
/*                                                             */
/* Das Programm berechnet rekursiv die Fakulttsfunktion n!    */
/***************************************************************/

#include <stdio.h>
#include <conio.h>

/* Die Funktion fak(n) berechnet rekursiv den Wert von n!
   anhand der folgenden Regeln:
   n! = 1           fuer n = 0 oder n = 1
   n! = n * (n-1)!  fuer n>1               */

long fak(unsigned n) {

 if (n<=1) return 1;

   else return n*fak(n-1);

}

/* Hauptprogramm */

main() {

 unsigned eingabe;

 printf("Bitte n>=0 eingeben: ");
 scanf("%u",&eingabe);

 printf("\nfak(%u) = %ld",eingabe,fak(eingabe));

 getch();

}

